=== debian/changelog ===
mbedtls (3.6.2-3ubuntu1) plucky; urgency=medium

  * Merge with Debian; remaining changes:
    - Lower optimization level to O2 on ppc64el to fix a test failure

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Nov 2024 19:55:00 +0100

mbedtls (3.6.2-3) unstable; urgency=medium

  [ Reinhard Tartler ]
  * Update 100-fix-gcc14-build to patch the correct file

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 17 Nov 2024 18:23:19 +0100

mbedtls (3.6.2-2ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Lower optimization level to O2 on ppc64el to fix a test failure
    - Fix gcc-14 patch

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 09 Nov 2024 20:23:53 +0100

mbedtls (3.6.2-2) unstable; urgency=medium

  * d/patches: fix builds with GCC 14.
    Thanks to Adrian, Christian, and Emilio for the report! (Closes: #1085354)

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 06 Nov 2024 12:54:54 +0100

mbedtls (3.6.2-1ubuntu4) plucky; urgency=medium

  * revert stringop-overflow ignoring, using O2 is enough to fix the tests

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 30 Oct 2024 22:05:57 +0100

mbedtls (3.6.2-1ubuntu3) plucky; urgency=medium

  * Lower optimization level to O2 on ppc64el to fix a test failure

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 30 Oct 2024 21:00:19 +0100

mbedtls (3.6.2-1ubuntu2) plucky; urgency=medium

  * Also ignore stringop-overflow due to ppc64el FTBFS
    - https://github.com/Mbed-TLS/mbedtls/issues/9743

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 30 Oct 2024 20:07:20 +0100

mbedtls (3.6.2-1ubuntu1) plucky; urgency=medium

  * debian/patches/100-fix-gcc14-build.patch
    upstream build fix for arm64 FTBFS on gcc-14 (Closes: #1085354)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 30 Oct 2024 20:01:33 +0100

mbedtls (3.6.2-1) unstable; urgency=low

  * New upstream version 3.6.2
  * d/.symbols: add new symbols, mark private as optional
  * d/watch: fixup checking of new 3.6 releases

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 21 Oct 2024 16:25:05 +0200

mbedtls (3.6.0-3) unstable; urgency=medium

  * Upload to unstable

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 17 Oct 2024 23:06:32 +0200

mbedtls (3.6.0-2) experimental; urgency=medium

  * d/.symbols: mark aesni symbols as x86-only

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 10 Apr 2024 07:27:06 +0200

mbedtls (3.6.0-1) experimental; urgency=medium

  * New upstream version 3.6.0
    - TLS 1.3 enabled by default. Closes: #971393
    - MBEDTLS_NIST_KW_C enabled by default. Closes: #1053533
    - Fixes CVE-2024-28960 (fixed in 2.28.8 too)
  * d/control: new SONAME, new packages
  * d/copyright: document Project Everest copyright
  * d/libmbedtls-dev.install: install new CMake Config files (Closes: #1036231)
  * d/patches: skip compiling 3rdparty code
  * d/tests: test new CMake Config files
  * d/tests/selftest: use the new pkg-config files
  * d/watch: switch to 3.6.x LTS branch
  * d/watch: use official release tarball

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 01 Apr 2024 22:55:20 +0200
