=== debian/watch ===
version=4
#just show LTS updates
opts="searchmode=plain, \
  pgpmode=none" \
https://api.github.com/repos/Mbed-TLS/mbedtls/releases \
https://github.com/Mbed-TLS/mbedtls/releases/download/[^/]+/mbedtls-(3.6.\d+).tar.bz2

#show all versions
#opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/mbedtls-$1\.tar\.gz/ \
#  https://github.com/Mbed-TLS/mbedtls/tags .*/v?(\d\S+)\.tar\.gz
