## mbedtls 3.6.3

=== debian/changelog ===
mbedtls (3.6.3-1) unstable; urgency=medium

  * New upstream version 3.6.3
    - Fixes CVE-2025-27809
    - Fixes CVE-2025-27810
    - Closes: #1101499
  * d/control: use my @debian.org email address
  * d/control: apply X-Style: black
  * d/control: declare dpkg-build-api = 1
  * d/.symbols: mark private symbol as optional, add new ones

 -- Andrea Pappacoda <tachi@debian.org>  Sat, 05 Apr 2025 15:45:07 +0200
