=== debian/changelog ===
mbedtls (3.6.4-2) unstable; urgency=medium

  * d/libmbedtls21.symbols: add new 3.6.4 symbols

 -- Andrea Pappacoda <tachi@debian.org>  Mon, 14 Jul 2025 15:19:49 +0200

mbedtls (3.6.4-1) unstable; urgency=medium

  * New upstream version 3.6.4
    - Closes: #1108785 (CVE-2025-52496)
    - Closes: #1108786 (CVE-2025-52497)
    - Closes: #1108787 (CVE-2025-49600)
    - Closes: #1108788 (CVE-2025-49601)

 -- Andrea Pappacoda <tachi@debian.org>  Sun, 13 Jul 2025 13:26:04 +0200
