=== debian/control ===
--- 
+++ 
@@ -1,17 +1,26 @@
 Source: mbedtls
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian IoT Maintainers <debian-iot-maintainers@alioth-lists.debian.net>
-Uploaders: Andrea Pappacoda <andrea@pappacoda.it>
-Standards-Version: 4.6.2
-Build-Depends: dpkg-dev (>= 1.22.5), cmake, debhelper-compat (= 13)
-Build-Depends-Arch: faketime <!nocheck>, python3:any
-Build-Depends-Indep: doxygen <!nodoc>, graphviz <!nodoc>, python3
-Rules-Requires-Root: no
+Maintainer: Debian IoT Maintainers <debian-iot-maintainers@alioth-lists.debian.net>
+Uploaders:
+ Andrea Pappacoda <tachi@debian.org>,
+Standards-Version: 4.7.2
+Build-Depends:
+ debhelper-compat (= 13),
+ dpkg-build-api (= 1),
+ dpkg-dev (>= 1.22.5),
+ cmake,
+Build-Depends-Arch:
+ faketime <!nocheck>,
+ python3:any,
+Build-Depends-Indep:
+ doxygen <!nodoc>,
+ graphviz <!nodoc>,
+ python3,
 Homepage: https://www.trustedfirmware.org/projects/mbed-tls/
 Vcs-Git: https://salsa.debian.org/debian-iot-team/mbedtls.git
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/mbedtls
+X-Style: black
 
 Package: libmbedtls-dev
 Architecture: any
@@ -21,8 +30,9 @@
  libmbedcrypto16 (= ${binary:Version}),
  libmbedtls21 (= ${binary:Version}),
  libmbedx509-7 (= ${binary:Version}),
- ${misc:Depends}
-Suggests: libmbedtls-doc
+ ${misc:Depends},
+Suggests:
+ libmbedtls-doc,
 Description: lightweight crypto and SSL/TLS library - development files
  mbed TLS (formerly known as PolarSSL) is a lean open source crypto library for
  providing SSL and TLS support in your programs. It offers an intuitive API and
@@ -43,7 +53,9 @@
 Package: libmbedcrypto16
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: lightweight crypto and SSL/TLS library - crypto library
  mbed TLS (formerly known as PolarSSL) is a lean open source crypto library for
  providing SSL and TLS support in your programs. It offers an intuitive API and
@@ -64,7 +76,9 @@
 Package: libmbedtls21
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: lightweight crypto and SSL/TLS library - tls library
  mbed TLS (formerly known as PolarSSL) is a lean open source crypto library for
  providing SSL and TLS support in your programs. It offers an intuitive API and
@@ -85,7 +99,9 @@
 Package: libmbedx509-7
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: lightweight crypto and SSL/TLS library - x509 certificate library
  mbed TLS (formerly known as PolarSSL) is a lean open source crypto library for
  providing SSL and TLS support in your programs. It offers an intuitive API and
@@ -107,8 +123,11 @@
 Architecture: all
 Multi-Arch: foreign
 Section: doc
-Depends: libjs-jquery, ${misc:Depends}
-Suggests: libmbedtls-dev
+Depends:
+ libjs-jquery,
+ ${misc:Depends},
+Suggests:
+ libmbedtls-dev,
 Description: lightweight crypto and SSL/TLS library - documentation
  mbed TLS (formerly known as PolarSSL) is a lean open source crypto library for
  providing SSL and TLS support in your programs. It offers an intuitive API and
