=== debian/rules ===
--- 
+++ 
@@ -6,11 +6,6 @@
 # Required as libmbedtls-dev ships .a files
 #export DEB_CFLAGS_MAINT_APPEND   = -ffat-lto-objects
 #export DEB_CXXFLAGS_MAINT_APPEND = -ffat-lto-objects
-
-ifeq (ppc64el,$(DEB_HOST_ARCH))
-export DEB_CFLAGS_MAINT_STRIP=-O3
-export DEB_CFLAGS_MAINT_APPEND=-O2
-endif
 
 UPSTREAM_DATE = $(shell awk '/^= .* [0-9-]*$$/ { print $$NF; exit }' ChangeLog)
