=== debian/tests/control ===
Tests:
 build,
 cmake,
 selftest,
Depends:
 cmake,
 gcc,
 libc6-dev | libc-dev,
 pkg-config,
 @,
