## mbedtls 3.6.5

=== debian/changelog ===
mbedtls (3.6.5-0.1ubuntu2) resolute; urgency=medium

  * Upstream fix 668 for ppc64el build failure
  * Also export -Wno-stringop-overflow on ppc64el
    - see https://github.com/Mbed-TLS/TF-PSA-Crypto/pull/668

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 20 Jan 2026 16:49:52 +0100

mbedtls (3.6.5-0.1ubuntu1) resolute; urgency=medium

  * Merge with Debian; remaining changes:
    - Lower optimization level to O2 on ppc64el to fix a test failure
      https://github.com/Mbed-TLS/mbedtls/issues/9743

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 13 Dec 2025 12:17:33 +0100

mbedtls (3.6.5-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release.
    - CVE-2025-54764: Side channel in RSA key generation and operations
      (Closes: #1118750)
    - CVE-2025-59438: Padding oracle through timing of cipher error reporting
      (Closes: #1118752)

 -- Adrian Bunk <bunk@debian.org>  Fri, 14 Nov 2025 22:00:32 +0200
